Package com.io7m.jtensors.core.parameterized.vectors

# Class PVector3L<T>

java.lang.Object
com.io7m.jtensors.core.parameterized.vectors.PVector3L<T>

Type Parameters:
  `T` - A phantom type parameter

All Implemented Interfaces:
  `PVector3LType<T>`, `PVectorReadable2LType<T>`, `PVectorReadable3LType<T>`, `VectorReadable2LType`, `VectorReadable3LType`, `VectorComputationalType`

    public final class PVector3L<T>
    extends java.lang.Object
    implements PVector3LType<T>

The type of 3D `long`-typed vectors.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `PVector3L.Builder<T>` | Builds instances of type `PVector3L`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static <T> PVector3L.Builder<T>` | `builder()` | Creates a builder for `PVector3L`.
  `static <T> PVector3L<T>` | `copyOf​(PVector3LType<T> instance)` | Creates an immutable copy of a `PVector3LType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `PVector3L` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `x`, `y`, `z`.
  `static <T> PVector3L<T>` | `of​(long x, long y, long z)` | Construct a new immutable `PVector3L` instance.
  `java.lang.String` | `toString()` | Prints the immutable value `PVector3L` with attribute values.
  `PVector3L<T>` | `withX​(long value)` | Copy the current immutable object by setting a value for the `x` attribute.
  `PVector3L<T>` | `withY​(long value)` | Copy the current immutable object by setting a value for the `y` attribute.
  `PVector3L<T>` | `withZ​(long value)` | Copy the current immutable object by setting a value for the `z` attribute.
  `long` | `x()` |
  `long` | `y()` |
  `long` | `z()` |

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public long x()
    Specified by:
      `x` in interface `PVector3LType<T>`
    Specified by:
      `x` in interface `VectorReadable2LType`
    Returns:
      The value of the `x` attribute

  - ### y

    public long y()
    Specified by:
      `y` in interface `PVector3LType<T>`
    Specified by:
      `y` in interface `VectorReadable2LType`
    Returns:
      The value of the `y` attribute

  - ### z

    public long z()
    Specified by:
      `z` in interface `PVector3LType<T>`
    Specified by:
      `z` in interface `VectorReadable3LType`
    Returns:
      The value of the `z` attribute

  - ### withX

    public final PVector3L<T> withX​(long value)
    Copy the current immutable object by setting a value for the `x` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy of the `this` object

  - ### withY

    public final PVector3L<T> withY​(long value)
    Copy the current immutable object by setting a value for the `y` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy of the `this` object

  - ### withZ

    public final PVector3L<T> withZ​(long value)
    Copy the current immutable object by setting a value for the `z` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for z
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `PVector3L` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`, `z`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `PVector3L` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static <T> PVector3L<T> of​(long x, long y, long z)
    Construct a new immutable `PVector3L` instance.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
      `z` - The value for the `z` attribute
    Returns:
      An immutable PVector3L instance

  - ### copyOf

    public static <T> PVector3L<T> copyOf​(PVector3LType<T> instance)
    Creates an immutable copy of a `PVector3LType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable PVector3L instance

  - ### builder

    public static <T> PVector3L.Builder<T> builder()
    Creates a builder for `PVector3L`.

         PVector3L.&lt;T&gt;builder()
            .setX(long) // required x
            .setY(long) // required y
            .setZ(long) // required z
            .build();

    Type Parameters:
      `T` - generic parameter T
    Returns:
      A new PVector3L builder